<template>
  <div class="page page__promotion">
    <div
      class="container"
      :class="{ 'invisible opacity-0 h-0': promotionShowed }"
    >
      <div class="page__header page__header--center">
        <h1 class="page__title">{{ $t("promotions") }}</h1>
      </div>
      <TabPanelHeader
        :tabs="tabs"
        :init-tab="tabs[0].value"
        @on-tab-change="updateActiveTab"
      />
      <div class="mt-4">
        <div v-show="displayingPromotions.length <= 0" class="empty">
          <div class="empty__wrapper">
            <img
              :src="
                getAssetImage(
                  'assets/theme/black_modern_1/images/stay_tuned.png'
                )
              "
              alt="empty"
            />
            <h3 class="no-promotion-text">
              {{ $t("more_promotions_coming_soon!_stay_tuned") }}
            </h3>
            <h3 class="no-promotion-text">{{ assignHashText }}</h3>
          </div>
        </div>
        <ul class="promotion__list">
          <PromotionItem
            v-for="promotion in displayingPromotions"
            :key="promotion.Title"
            :promotion="promotion"
            :is-processing="isProcessing"
            :is-applying="isProcessing && applyRequest.PromotionId === promotion.Id"
            :should-show-apply-button="buttonApplyPromotionEnabled(promotion)"
            :on-click-spin-now="onClickSpinNow"
            :validateLuckyWheelbutton="validateLuckyWheelbutton(promotion)"
            @open="openPromotion(promotion)"
            @apply="onApplyPromotion(promotion)"
          />
        </ul>
      </div>
    </div>
    <div v-if="promotionShowed" class="container">
      <PromotionDetailModal
        :promotion="promotionShowed"
        :on-click-spin-now="onClickSpinNow"
        @close="closePromotion"
      ></PromotionDetailModal>
    </div>
  </div>
</template>

<script setup lang="ts">
import { computed, ref } from "vue";
import TabPanelHeader from "./components/ui/TabPanelHeader.client.vue";
import PromotionItem from "./components/PromotionItem.client.vue";
import PromotionDetailModal from "./components/promotion/PromotionDetailModal.client.vue";
import commonHelper from "@/utils/commonHelper";
import { Promotion } from "@/models/promotion/promotion";

const { getAssetImage } = commonHelper;
const lightBackground1 = `url(${getAssetImage(
  "assets/theme/black_modern_1/fonts/empty_bg_1.svg"
)}`;
const lightBackground2 = `url(${getAssetImage(
  "assets/theme/black_modern_1/fonts/bg_page-form_1.svg"
)}`;
const darkBackground1 = `url(${getAssetImage(
  "assets/theme/black_modern_1/fonts/bg_page-form-2.svg"
)}`;
const darkBackground2 = `url(${getAssetImage(
  "assets/theme/black_modern_1/fonts/bg_page-form.svg"
)}`;

const {
  promotions,
  assignHashText,
  onApplyPromotion,
  isProcessing,
  buttonApplyPromotionEnabled,
  applyRequest,
  onClickSpinNow,
  validateLuckyWheelbutton,
} = usePromotion();
const { $t } = useNuxtApp();
const tabs = [
  {
    label: $t("all"),
    value: "all",
  },
  {
    label: $t("first_deposit"),
    value: "first deposit",
  },
  {
    label: $t("common"),
    value: "common",
  },
  {
    label: $t("rebate"),
    value: "rebate",
  },
];
const activeTab = ref(tabs[0].value);

const displayingPromotions = computed(() => {
  if (activeTab.value === "all")
    return promotions.value.map((promotion) => new Promotion(promotion));
  if (activeTab.value === "common")
    return promotions.value.filter(
      (promotion) =>
        !promotion.PromotionType.toLowerCase().includes("rebate on") &&
        !promotion.PromotionType.toLowerCase().includes("first deposit")
    );
  const matchedPromotions = promotions.value.filter((promotion) =>
    promotion.PromotionType.toLowerCase().includes(
      activeTab.value.toLowerCase()
    )
  );
  return matchedPromotions.map((promotion) => new Promotion(promotion));
});

const updateActiveTab = (tab: string) => {
  activeTab.value = tab;
};
const promotionShowed = ref<Promotion | undefined>(undefined);
const scrollY = ref(0);

const openPromotion = (promotion: Promotion) => {
  scrollY.value = window.scrollY;
  promotionShowed.value = promotion;
};
const closePromotion = () => {
  if (!promotionShowed.value) return;
  promotionShowed.value = undefined;
  window.scrollTo({ top: scrollY.value });
};
const route = useRoute();
watch(
  () => [route.params, promotions.value],
  () => {
    const firstLuckyWheel = promotions.value.find(
      (item) => item.Id === Number(route.params.id)
    );
    if (firstLuckyWheel) {
      promotionShowed.value = firstLuckyWheel;
    }
  },
  { deep: true, immediate: true }
);
</script>

<style scoped lang="scss">
.page.page__promotion {
  margin-bottom: 0;
}
.container {
  margin: 0 auto;
  padding: 0 32px;
  max-width: 100%;
  width: 100%;
  -webkit-transition: padding 0.2s ease;
  transition: padding 0.2s ease;
  position: relative;
}
.page__header {
  position: relative;
  display: -webkit-box;
  display: -ms-flexbox;
  display: flex;
  -webkit-box-pack: justify;
  -ms-flex-pack: justify;
  justify-content: space-between;
  -webkit-box-align: center;
  -ms-flex-align: center;
  align-items: center;
  -ms-flex-wrap: wrap;
  flex-wrap: wrap;
  margin-bottom: 40px;

  &--center {
    -webkit-box-pack: center;
    -ms-flex-pack: center;
    justify-content: center;
  }
  .page__title {
    width: auto;
    margin: 0;
    font-size: 44px;
    line-height: 52px;
    font-style: normal;
    font-weight: 700;
    -webkit-transition: color 0.4s;
    transition: color 0.4s;
    color: var(--title-font-color);
  }
}
.promotion__list {
  display: flex;
  flex-direction: column;
  // max-width: 1160px;
}

@media (max-width: 980px) {
  .promotion__list {
    flex-direction: row;
    flex-wrap: wrap;
    gap: 1rem;
  }
  .promotion__item {
    margin-bottom: 0;
  }
}

html.dark .empty {
  background-image: v-bind(darkBackground1), v-bind(darkBackground2);
}

.empty {
  background-image: v-bind(lightBackground1), v-bind(lightBackground2);
  background-repeat: no-repeat;
  background-position: bottom left, top right;
  background-size: contain;
  margin: 2rem;
}
@media (max-width: 640px) {
  .empty {
    background-image: none;
  }
}

.empty__wrapper {
  max-width: 396px;
  margin: 0 auto;
  width: 100%;
  padding: 60px;
  background: var(--background2);
  -webkit-box-shadow: var(--box-shadow);
  box-shadow: var(--box-shadow);
  border-radius: 24px;
  text-align: center;
}

@media (max-width: 640px) {
  .empty__wrapper {
    padding: 48px;
  }
}

.empty h3 {
  font-size: 32px;
  line-height: 40px;
  margin-top: 10px;
  margin-bottom: 0;
  color: var(--title-font-color);
}

@media (max-width: 640px) {
  .empty h3 {
    font-size: 20px;
    line-height: 28px;
  }
}
@-moz-document url-prefix() {
  .no-promotion-text {
    word-wrap: break-word;
  }
}
</style>
